local modName = ...
local Addon = LibStub('AceAddon-3.0'):GetAddon(GetAddOnDependencies(modName))
local bar = Addon:CreateClass('Frame', Addon.Frame)
_G[modName] = bar
bar.master = Addon
bar.lib = LibStub('LibSharedMedia-3.0', true)

bar.frames = {}

function bar:New(name)
	local name = string.lower(name)
	local f = self.proto.New(self, name)
	f:Reload()
	bar.frames[name] = bar.frames[name] or f
	return f
end

local defaults = {
	focus = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'playerBR',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,			
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			},
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
	targettarget = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'targetRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 420,
		padH = 3,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,			
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			},
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
	target = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 235,
		padH = 3,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,			
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			}
		},
		
		buffs = {
			enable = true,
			anchor = 'BottomLeft',
			x = 12,
			y = 6,
			scale = 64,
			rows = 1,
		},
		debuffs = {
			enable = true,
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
	player = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		power = {
			anchor = 'TopLeft',
			x = 106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopLeft',
			x = 106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = 42,
			y = -12,
			anchor = 'TopLeft',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = 50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Left',
			angle  = 313,
			x = 45,
			y = 2,
			IsTopToBottom = true,
		},
		level = {
			anchor = 'Center',
			x = -63,
			y = -16, 
			justifyH = 2,
		},
		background = {
			anchor = 'TopLeft',
			x = 106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			}
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 225,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
	focustarget = {
		scale = .7,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,			
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			},
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
	playerpet = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,			
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			}
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
	},
}

local function check(source, target)
	--you may now add new defaults at will. ~Goranaws
	if not target then 
		target = {}
	end
	if not source then
		--return
	end
	for key, value in pairs(source) do
		if type(value) == 'table' then
			target[key] =check(value, target[key])
		else
			if (type(value) == 'boolean') then
				if target[key] == nil then
					target[key] = value
				end
 			else
 				target[key] = target[key] or value
 			end
		end
	end
	return target
end
bar.check = check

function bar:GetDefaults()
	local def
	if self and self.id and defaults[self.id] then 
		def = check(defaults[self.id])
	else
		def = CopyTable({
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'Center',
		padW = 0,
		width = 232,
		y = 0,
		x = 0,
		padH = 0,
		height = 100,
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
			enable = true,
		},
		power = {
			anchor = 'TopRight',
			x = -106,
			y = -52,
			height = 12,
			width = (119/232)*100,
			enable = true,
		},
		health = {
			anchor = 'TopRight',
			x = -106,
			y = -41,
			height = 12,
			width = (119/232)*100,
			enable = true,
		},
		focus = {
			x = -42,
			y = -12,
			anchor = 'TopRight',
			enable = true,
		},
		name = {
			width = 100,
			height = 12,
			anchor = 'Center',
			x = -50,
			y = 19,
			justifyH = 2,
			enable = true,
		},
		icons = {
			width = 45,
			height = 45,
			style = 'ROUND',
			scale = 130,
			anchor = 'Right',
			angle  = 313,
			x = -45,
			y = 2,
			IsTopToBottom = true,
			IsLeftToRight = false,
			enable = true,
		},
		level = {
			anchor = 'Center',
			x = 63,
			y = -16,
			justifyH = 2,		
			enable = true,	
		},
		background = {
			anchor = 'TopRight',
			x = -106,
			y = -22,
			width = (119/232)*100,
			height = 41,
			color = {
				r = 0,
				g = 0,
				b = 0,
				a = .5, 
			},
			enable = true,
		},
		buffs = {
			enable = true,
			anchor = 'BottomLeft',
			x = 12,
			y = 6,
			scale = 64,
			rows = 1,
		},
		debuffs = {
			enable = true,
		},
		cast = {	
			frameLevel = 2,
			frameLayer = 4,
			scale = 100,
			alpha = 100,
			width = 117,
			y = 17,
			x = 7,
			anchor = 'Left',
			height = 16,
			enable = true,
			showBG = false,
			textheight = 12,
		},
		overlay = {
			enable = true,	
		},
	})
	end
	return def
end

function bar:Reload()
	self.sets = self.sets or CopyTable(self:GetDefaults()) --check(self:GetDefaults(), self.sets)
	if self.Load then
		self:Load()
	end
	self:SetParent(self.parent or self:GetParent())
	self:Layout()
end

function bar:Disable()
	self:Free()
end

function bar:Layout()
	if self.UpdateComponents then
		self:UpdateComponents()
	else
		local pad = self:GetPadding()
		local w, h = self.sets.width + pad, self.sets.height + pad
		self:SetSize(w, h)
	end
end
